---
test:tests:
  image: registry.gitlab.com/sbenv/veroxis/images/sdks/rust:1.77.2-x86_64-unknown-linux-gnu
  needs: []
  interruptible: true
  script:
    - cargo-zigbuild test --target="x86_64-unknown-linux-gnu.2.17"

test:rustfmt:
  image: registry.gitlab.com/sbenv/veroxis/images/sdks/rust:1.77.2-x86_64-unknown-linux-gnu
  needs: []
  interruptible: true
  script:
    - cargo +nightly fmt -- --check

test:clippy:
  image: registry.gitlab.com/sbenv/veroxis/images/sdks/rust:1.77.2-x86_64-unknown-linux-gnu
  needs: []
  interruptible: true
  script:
    - cargo clippy --all-features -- -D warnings

build:x86_64-unknown-linux-gnu:release:
  image: registry.gitlab.com/sbenv/veroxis/images/sdks/rust:1.77.2-x86_64-unknown-linux-gnu
  needs: []
  only: [master]
  artifacts:
    paths: ["target/x86_64-unknown-linux-gnu/release/triton-gui"]
  interruptible: true
  script:
    - cargo +nightly zigbuild -Z "build-std=std,panic_abort" -Z "build-std-features=panic_immediate_abort" --release --target="x86_64-unknown-linux-gnu.2.17"

build:x86_64-pc-windows-gnu:release:
  image: registry.gitlab.com/sbenv/veroxis/images/sdks/rust:1.77.2-x86_64-pc-windows-gnu
  needs: []
  only: [master]
  artifacts:
    paths: ["target/x86_64-pc-windows-gnu/release/triton-gui.exe"]
  interruptible: true
  script:
    - cargo +nightly build -Z "build-std=std,panic_abort" -Z "build-std-features=panic_immediate_abort" --release --target="x86_64-pc-windows-gnu"

publish:release:
  image: registry.gitlab.com/sbenv/veroxis/images/sdks/alpine:3.20.2
  needs:
    - build:x86_64-unknown-linux-gnu:release
    - build:x86_64-pc-windows-gnu:release
  only: [master]
  artifacts:
    paths:
      - target/x86_64-unknown-linux-gnu/release/triton-gui
      - target/x86_64-pc-windows-gnu/release/triton-gui.exe
  script: echo
